# ANCOVA

# Problema 1

#(1)
pfinal<-c(36,41,39,42,49,40,48,39,45,44,35,37,42,34,32,
36,44,46,32,39,47,36,38,39,46,45,44,50,44,53) # respuesta
pini<-c(20,25,24,25,32,22,28,22,30,28,21,23,26,21,15,
23,29,27,19,24,25,19,16,18,26,26,24,32,23,31) # covariable
alimento<-gl(3,10,labels=c("Ali 1","Ali 2","Ali 3")) # factor
N<-length(pfinal)
N
a<-3
summary(pfinal)
tapply(pfinal, alimento,summary) # Entrega summary separado por potencia

# ver matrices de datos:

My<-matrix(pfinal,nrow=10,byrow=F)
My
Mx<-matrix(pini,nrow=10,byrow=F)
Mx
Al<-matrix(alimento,nrow=10,byrow=F)
Al
n<-nrow(Mx)
a<-N/n
n
a


# cajagrama:
boxplot(pfinal ~ alimento,main="Peso de cerdos") 

# grafico de puntos:
nalimento<-as.numeric(alimento)
plot(nalimento,pfinal,type="p",xlab="Alimento",ylab="Peso final",main="Peso de cerdos")

#-------------------------------------------------------

#(2) verificacion de supuestos:

# 1- igualdad de pendientes:

rangox<-c(min(pini),max(pini))
rangoy<-c(min(pfinal),max(pfinal))

par(new=F) # puntos y regresion variedad 1
k<-1
plot(pini[nalimento==k],pfinal[nalimento==k],main="Peso de cerdos",
col=k,xlim=rangox,ylim=rangoy,xlab="alimento",ylab="peso",pch=16)
abline(lm(pfinal[nalimento==k]~pini[nalimento==k]),col=k,lwd=2)

par(new=TRUE) # puntos y regresion variedad 2
k<-2
plot(pini[nalimento==k],pfinal[nalimento==k],col=k,xlim=rangox,ylim=rangoy,xaxt="n",xlab="",ylab="peso",pch=16)
abline(lm(pfinal[nalimento==k]~pini[nalimento==k]),col=k,lwd=2)

par(new=TRUE) # puntos y regresion variedad 3
k<-3
plot(pini[nalimento==k],pfinal[nalimento==k],col=k,xlim=rangox,ylim=rangoy,xaxt="n",xlab="",ylab="peso",pch=16)
abline(lm(pfinal[nalimento==k]~pini[nalimento==k]),col=k,lwd=2)

legend("topleft",c("Alimento 1","Alimento 2","Alimento 3"),text.col=1:3)

# o bien, si el termino interaccion alimento*pini no es significativo, 
# se cumple el supuesto:

anova1<-aov(pfinal~alimento+pini+alimento*pini) 
summary(anova1)

# 2- Linealidad de pendientes.

# Se observa las pendientes o las lneas de tendencia entre los grupos. 
# Debern verse ms o menos iguales.
plot(pini, pfinal, col = alimento, xlab = "Peso inicial", ylab = "Peso final",pch=16)

# 3- Igualdad de los grupos respecto a la covariable.

# Realizar un ANOVA con la covariable y los tratamientos. 
# No deber encontrarse diferencias significativas:

anova2<-aov(pini~alimento)
summary(anova2)

# 4- Homogeneidad de varianzas.
 
# Hiptesis:
# Ho:La varianza es homogenea.
# Ha:La varianza no es homogenea.

# Prueba de Levene.
# Para realizar la prueba de homogeneidad de varianzas,
# se instala el paquete car
#install.packages("car")
library(car)
leveneTest(pfinal ~ alimento, center = mean) 

# 5- Normalidad de los residuos

# Prueba de normalidad Shapiro-Wilk
# Hiptesis:
# Ho:Los residuos siguen la distribucin normal.
# Ha:Los residuos no siguen la distribucin normal.
# Prueba de normalidad de Shapiro-wilk para los residuos:
# Anlisis de covarianza usando la funcin modelo lineal (lm) Linear mode
anova3<-lm(pfinal~alimento+pini)
shapiro.test(anova3$res)

#--------------------------------------------------------

#(3) analisis de covarianza

anova4 <- aov(pfinal~alimento+pini)
anova(anova4)

# si se hiciera un anlisis de varianza comun sin considerar la covariable,
# toda la variacion debido a la covariable ira a error y el tratamiento
# apenas seria significativo:

anova5 <- aov(pfinal~alimento)
anova(anova5)

#--------------------------------------------------------

# estimacion de parmetros

anova4$coeff # coeficiente de x

model.tables(anova4) # pendiente (y estim. de efectos con la condicion de R)

##########################################################

# Calculos a mano: 

4# sumas:

ssumX<-sum(Mx) # suma de todos los X
ssumX
ssumY<-sum(My) # suma de todos los Y
ssumY
sumYip2<-n*sum(colMeans(My)*colMeans(My)) # suma sobre i de los Yipunto cuadr
sumYip2
sumXip2<-n*sum(colMeans(Mx)*colMeans(Mx)) # suma sobre i de los Xipunto cuadr
sumXip2
sumXipYip<-n*sum(colMeans(Mx)*colMeans(My)) # suma sobre i de los Xipunto por Yipunto
sumXipYip

# sumas de cuadrados y productos:

ssumX2<-sum(Mx*Mx) # suma de los cuadrados de todos los X
ssumX2
ssumY2<-sum(My*My) # suma de los cuadrados de todos los Y
ssumY2
ssumXY<-sum(My*Mx) # suma de los productos de los X por los Y
ssumXY

# factores de correccin:

fcX<-ssumX*ssumX/N # factor de correccion de las X
fcX
fcY<-ssumY*ssumY/N # factor de correccion de las Y
fcY
fcXY<-ssumX*ssumY/N # factor de correccion de las X por Y
fcXY

# terminos T:

Sxx<-ssumX2-fcX
Sxx
Syy<-ssumY2-fcY
Syy
Sxy<-ssumXY-fcXY
Sxy

# terminos A:

Axx<-sumXip2-fcX
Axx
Ayy<-sumYip2-fcY
Ayy
Axy<-sumXipYip-fcXY
Axy

# terminos E:

Exx<-ssumX2-sumXip2
Exx
Eyy<-ssumY2-sumYip2
Eyy
Exy<-ssumXY-sumXipYip
Exy

# valores ajustados por regresion:

Syyaj<-Syy-Exy*Exy/Exx
Eyyaj<-Eyy-Exy*Exy/Exx
Ayyaj<-Syyaj-Eyyaj
Syyaj
Eyyaj
Ayyaj

# Ancova:

SSreg<-Exy*Exy/Exx
SStrat<-Ayyaj # = Syy-Eyy
SSerr<-Eyyaj # = Eyy-Exy*Exy/Exx
SStot<-Syy
SSreg
SStrat
SSerr
SStot

# comparar con:

anova(anova4)

#-----------------------------------

# Anova sin corregir por la covariable:

SStrat<-Syy-Eyy
SStot<-Syy
SSerr<-Eyy
SStrat
SSerr
SStot

# comparar con:

anova(anova5)

###################################################









