# MEDIDAS REPETIDAS

# Problema 1 - Datos longitudinales

#(1) Ingreso de datos

Intel<-read.table(header=TRUE,text='
ID Mes30  Mes36  Mes42 Mes48
1 108	 96	 110	 122
2 103	 117	 127	 133
3 96	 107	 106	 107
4 84	 85	 92	 99
5 118	 125	 125	 116
6 110	 107	 96	 91
7 129	 128	 123	 128
8 90	 84	 101	 113
9 84	 104	 100	 88
10 96	 100	 103	 105
11 105 114	 105	 112
12 113 117	 132	 130
')
attach(Intel)
edad<-gl(n=4,k=12,length=48,labels=c("mes30","mes36","mes42","mes48")) # generar niveles
ID<-rep(1:12,times=4)
ID<-as.factor(ID)# generar niveles del facto ID 
inteli<-c(Mes30,Mes36,Mes42,Mes48) # inteligencia como vector

datos<-data.frame(ID,edad,inteli)
names(datos)<-c("ID","edad","inteligencia")
datos

# grafico de interaccion:

interaction.plot(trace.factor = ID, x.factor = edad,
                 response = inteli, fun = "mean",legend = TRUE,
                 col = 1:12,ylim=c(0,max(inteligencia), type = "b") # fijarse en los limites

interaction.plot(trace.factor = ID, x.factor = edad,
                 response = inteli, fun = "mean",legend = TRUE,
                 col = 1:12, type = "b")

#############################################################

#(2) analisis de varianza:

anovaMR<-aov(inteli~edad+Error(ID/edad)) # sujetos + edad dentro de sujetos
# edad est anidado en ID
# observacio: aov solo debe usarse con datos balanceados.
summary(anovaMR)

#################################################################

# Problema 2 - split-plot

#(3) lectura de datos

glicogeno<-read.table(header=TRUE,text='
sujeto glico alimento  rata prepar ci  cj  ck cl
1       127   T1      R   P1  1 1 1 1  
2       127   T1      R   P2  1 2 1 1
3       124   T1      R   P1  1 1 1 2      
4       123   T1      R   P2  1 2 1 2
5       126   T1      R   P1  1 1 1 3    
6       122   T1      R   P2  1 2 1 3       
7       146   T1      S   P1  1 1 2 1   
8       136   T1      S   P2  1 2 2 1
9       148   T1      S   P1  1 1 2 2   
10       137   T1      S   P2  1 2 2 2   
11       145   T1      S   P1  1 1 2 3    
12       139   T1      S   P2  1 2 2 3   
13       157   T2      T   P1  2 1 1 1   
14       157   T2      T   P2  2 2 1 1
15       155   T2      T   P1  2 1 1 2   
16       153   T2      T   P2  2 2 1 2
17       157   T2      T   P1  2 1 1 3  
18       153   T2      T   P2  2 2 1 3
19       151   T2      U   P1  2 1 2 1
20       144   T2      U   P2  2 2 2 1
21       150   T2      U   P1  2 1 2 2
22       146   T2      U   P2  2 2 2 2
23       145   T2      U   P1  2 1 2 3
24       147   T2      U   P2  2 2 2 3
25       130   T3      V   P1  3 1 1 1
26       131   T3      V   P2  3 2 1 1
27       128   T3      V   P1  3 1 1 2
28       127   T3      V   P2  3 2 1 2
29       129   T3      V   P1  3 1 1 3
30       126   T3      V   P2  3 2 1 3
31       134   T3      W   P1  3 1 2 1
32       132   T3      W   P2  3 2 2 1
33       132   T3      W   P1  3 1 2 2
34       133   T3      W   P2  3 2 2 2
35       132   T3      W   P1  3 1 2 3
36       135   T3      W   P2  3 2 2 3
')
str(glicogeno)

library(lattice) # xyplot usa lattice

with(glicogeno, xyplot(glico ~ factor(prepar) | alimento, groups = rata, aspect = "xy")) 
# with permite utilizar las variables sin usar glicogeno$glico, etc.
# otra opcion es antes correr
attach(glicogeno)
# y luego
xyplot(glico ~ factor(prepar) | alimento, groups = rata, aspect = "xy") # usa lattice

#########################################################################

#(4) Anova

anovaSP <- aov(glico ~ alimento* prepar + Error(rata/alimento))
# rata est anidado en alimento
summary(anovaSP)

#########################################################################

# Calculo ANOVA a mano

a<-3 # alimentos
b<-2 # preparaciones
r<-2 # replicas
s<-3 # bloques

# calculos preliminares:

ci=glicogeno$ci
cj<-glicogeno$cj
ck<-glicogeno$ck
cl<-glicogeno$cl

Yi<-numeric(a)
Yi<-tapply(glico,ci,sum)

Yj<-numeric(b)
Yj<-tapply(glico,cj,sum)

Yk<-numeric(r)
Yk<-tapply(glico,ck,sum)

Yij<-matrix(0,nrow=a,ncol=b)
ind<-list(ci,cj)
Yij<-tapply(glico,ind, sum)

Yik<-matrix(0,nrow=a,ncol=s)
ind<-list(ci,ck)
Yik<-tapply(glico,ind, sum)

Yjk<-matrix(0,nrow=b,ncol=r)
ind<-list(cj,ck)
Yjk<-tapply(glico,ind, sum)

Yil<-matrix(0,nrow=a,ncol=s)
ind<-list(ci,cl)
Yil<-tapply(glico,ind, sum)

Yijk<-array(0,dim<-c(3,2,2))
ind<-list(ci,cj,ck)
Yijk<-tapply(glico,ind, sum)

# sumas de cuadrados:

fc<-sum(Yi)^2/(a*b*r*s) #ok factor de correccion

SSA<-sum(Yi^2)/(b*r*s)-fc #ok Alimento
SSA
SSer1<-sum(Yik^2)/(b*s)-sum(Yi^2)/(b*r*s) #ok Error 1
SSer1
#--------------------------------------
SStot1<-sum(Yik^2)/(b*s)-fc #ok Total 1
SStot1
#--------------------------------------
SSB<-sum(Yj^2)/(a*s*r)-fc #ok Prep
SSB
SSAB<-sum(Yij^2)/(s*r)-sum(Yi^2)/(b*s*r)-sum(Yj^2)/(a*s*r)+fc #ok Alim*Prep
SSAB
SSer2<-sum(glico^2)-sum(Yik^2)/(b*s)-sum(Yij^2)/(s*r)+sum(Yi^2)/(b*s*r) #ok error2
SSer2
#---------------------------------------
SStot2<-sum(glico^2)-fc #ok Total2
SStot2

#grados de libestad:

glA<-a-1
gler1<-a*(r-1)
glT1<-a*r-1
glB<-b-1
glAB<-(a-1)*(b-1)
gler2<-a*(b*r*s-r-b+1)
glT2<-a*b*r*s-1

# cuadrados medios:

MSA<-SSA/glA
MSB<-SSB/glB
MSAB<-SSAB/glAB
MSer1<-SSer1/gler1
MSer2<-SSer2/gler2

#cuocientes F:

FA<-(SSA*gler1)/(glA*SSer1)
FB<-(SSB*gler2)/(glB*SSer2)
FAB<-(SSAB*gler2)/(glAB*SSer2)

# valores p:

vpA<-pf(FA,glA,gler1,lower=FALSE)
vpB<-pf(FB,glB,gler2,lower=FALSE)
vpAB<-pf(FAB,glAB,gler2,lower=FALSE)

#tabla ANOVA:
cat("Fuente var.  gr. lib. suma cuad. cuo F    valor p \n",
"Entre \n",
"alim          ",glA,"   ",round(SSA,1),"  ",round(FA,5),"  ",round(vpA,5),"\n",
"error entre   ",gler1,"   ",round(SSer1,1),"\n",
"total entre   ",glT1,"   ",round(SStot1,1),"\n",
"Dentro \n",
"preparacion   ",glB,"   ",round(SSB,1),"     ",round(FB,5),"  ",round(vpB,5),"\n",
"alim*prep     ",glAB,"   ",round(SSAB,1),"    ",round(FAB,5),"  ",round(vpAB,5),"\n",
"error dentro  ",gler2,"  ",round(SSer2,1),"\n",
"total         ",glT2,"  ",round(SStot2,1),"\n")

anovaSP <- aov(glico ~ alimento* prepar + Error(rata/alimento))
summary(anovaSP)

############################################################
###############################################################




rm(list=ls())  # limpiar memoria

