# REGRESION LINEAL SIMPLE - 

# Problema 1 - Diametro y altura.

#(1) 

# leer datos:

arbol<-read.table(header=TRUE,text='
altura  	diametro
12  	23
15  	45
13  	38
13  	36
14  	35
11  	23
12  	18
16  	46
')

View(arbol)
arbol
attach(arbol)
altura
diametro
summary(arbol)

plot(diametro,altura,main="Diagrama de Dispersin de las altura vs anuncios")

# varianzas, covarianza y correlacion:

var(diametro)
var(altura)
cov(diametro,altura)
cor(diametro,altura)

# -----------------------------------------

#(2) 
# Regresion:

maltura<-lm(altura~diametro)

# ----------------------------------------

#(3)
# pruebas t e intervalos de confianza

summary(maltura)
confint(maltura)
confint(maltura,level=0.99)

# ----------------------------------------

#(4)
# analisis de varianza

anova1<-aov(maltura) # solo anova
summary(anova1)
summary(maltura)

# ------------------------------------------

#(5)
# valores ajustados, residuos

ajustados<-fitted(maltura) # valores ajustados

residuos<-residuals(maltura) # residuos
resEstand<-rstandard(maltura) # residuos estandarizados

resultados<-data.frame(diametro,altura,ajustados,residuos,resEstand)
resultados

# ------------------------------------------------

#(6)
# verificacion de supuestos

# normalidad. Test de shapiro-wilks:

shapiro.test(residuos) # prueba de normalidad

install.packages("nortest")
library(nortest)

lillie.test(residuos) # prueba Kolmogorov-Smirnov de normalidad

install.packages("lmtest")
library(lmtest)

dwtest(altura~diametro,alternative="two.sided",data=arbol) # prueba Durbin-Watson para normalidad

# graficos de residuos y otros:
plot(resEstand,ajust)

bptest(maltura) # homosedasticidad). Test de Breusch-Pagan para homosedasticidad

# ------------------------------------------------------------

#(7) 
# predicciones

altura
predict(maltura,interval="confidence") # intervalos de conf. para el promedio

predict(maltura,interval="predict") # intervalo de prediccion para una observacion

nuevos_anuncios<-data.frame(diametro=c(2,7))
nuevos_anuncios
predict(maltura,nuevos_anuncios,interval="confidence")

predict(maltura,nuevos_anuncios,interval="prediction")

# ---------------------------------------------------------------

#(8) calibracion
install.packages("investr")
library(investr)

maltura<-lm(altura~diametro,data=arbol)
res<-calibrate(maltura, y0 = 13.5, mean.response = FALSE,level=0.95)
res

plotFit(maltura, interval = "confidence", shade = TRUE,  col.pred = "skyblue")
abline(h = 3, v = c(res$lower, res$estimate, res$upper), lty = 2)

# mean.response=TRUE corresponde a interval ="confidence" 
# intervalo para la media
# mean.response=FALSE corresponde a interval ="prediction" 
# intervalo para una observacion

######################################################################

