# ANALISIS CLASICO DE SERIES DE TIEMPO

#(1) Problema 1 URGENCIAS HOSPITALARIAS

install.packages("readxl")
library(readxl)

Urgencias<-read_excel(file.choose(),col_names=TRUE) # leer archivo excel
head(Urgencias)
str(Urgencias)
attach(Urgencias)
n<-length(urgencias)
obs<-1:n # crear nueva variable

plot(obs,urgencias,type="l",xlab="mes", ylab="urgencias",main="Urgencias por mes",ylim=c(0,max(urgencias)))

#---------------------------------

#(2) tendencia:

tend<-lm(urgencias~obs)
abline(tend)

tendencia<-tend$coefficients[1]+tend$coefficients[2]*obs
sinTendencia<-urgencias-tendencia # eliminacion de la tendencia

# grafico sin tendencia
plot(obs,sinTendencia,type="l",xlab="mes", ylab="urgencias",main="Urgencias sin tendencia")

#-------------------------------------------------

#(3) componente estacional:

indices<-rep(1:12,4)
indices
estac<-tapply(sinTendencia,indices,mean)
estac
estac<-c(estac,estac,estac,estac)
estac
plot(obs,estac,main="Urgencias - estacionalidad",xlab="mes", ylab="urgencias",ylim=c(min(estac),max(estac)),type="l")

# componente aleatoria:
aleatoria<-sinTendencia-estac
plot(obs,aleatoria,main="Urgencias - comp. aleatorio",xlab="mes", ylab="urgencias",ylim=c(min(aleatoria),max(aleatoria)),type="l")

#-------------------------------------------------------

#(4) reconstruccin de la serie (serie teorica):

urgenciasTeor<-tendencia+estac

plot(obs,urgencias,main="Urgencias mensuales",xlab="mes", ylab="urgencias teoricas",col="red",ylim=c(0,max(urgenciasTeor)),lwd=2,type="l")

par(new = TRUE) # permite superponer serie teorica
plot(obs,urgenciasTeor,main="",axes = FALSE,xlab="", ylab="",col="black",ylim=c(0,max(urgenciasTeor)),lwd=2,type="l")
legend("bottomright",c("teorica","observada"),col=c("black","red"),lwd=2)

########################################################################
