# MEDIA MOVIL Y HOLT WINTERS (con comandos rollmean y HoltWinters)

install.packages("readxl")
library(readxl)

# sink(file.choose())
Urgencias<-read_excel(file.choose(),col_names=TRUE) # leer archivo excel
Urgencias

str(Urgencias)
urgencias<-Urgencias$urgencias
N<-length(urgencias)
N

# Transformar el conjunto de datos en datos de serie de tiempo, con estacionalidad de 7 dias:
y<-ts(urgencias,freq=12)

# Graficar la serie de tiempo:
plot.ts(y,main="Urgencias hospitalarias",xlab="Mes",ylab="Casos x1000")

# o bien 
obs<-1:N
plot(obs,urgencias,main="Urgencias hospitalarias",type="l",xlab="Mes",ylab="Casos x1000",ylim=c(0,max(y)))

###########################################################################

# Suavizamiento de media movil

library(zoo)

mm7<-rollmean(y, k = 7 , fill = NA, align = "left")
mm14<-rollmean(y, k = 14 , fill = NA, align = "left")

#graficos:

plot.ts(y,main="Urgencias por mes x 1000",xlab="Mes",ylab="Casos",col="grey",lwd=2)
lines(mm7,col="blue",ylab="",xlab="",yaxt="n",xaxt="n",lwd=2)
lines(mm14,col="red",ylab="",xlab="",yaxt="n",xaxt="n",lwd=2)

legend("topleft",c("original","mm7","mm14"),text.col=c("grey","blue","red"))


###########################################################################

# Ajustar el modelo exponencial:
HW1<-HoltWinters(y,seasonal="additive",beta=FALSE,gamma=FALSE)
plot(HW1)

HW1$SSE # suma de cuadrados del error

# fitted(HW1) # entrega los valores ajustados, el nivel

# ponderacion:
HW1$alpha

#--------------------------------

predicciones1 <- predict(HW1, n.ahead = 1, prediction.interval = TRUE, level = 0.95) 
# incluye intervalo de prediccion

predicciones1

plot(HW1, predicciones1)

#----------------------------------------------------------------------------

# Ajustar el modelo de Holt:

HW2<-HoltWinters(y,seasonal="additive",gamma=FALSE)
plot(HW2)

HW2$SSE # suma de cuadrados del error


# ponderaciones:
HW2$alpha
HW2$beta

fitted(HW2) # entrega los valores ajustados, el nivel, la tendencia

# ------------------------

# predicciones 

predicciones2 <- predict(HW2, n.ahead = 3, prediction.interval = TRUE, level = 0.95) 
# incluye intervalo de prediccion

predicciones2

plot(HW2, predicciones2)

########################################################################

# Ajustar el modelo de Holt-Winters aditivo:

HW3<-HoltWinters(y,seasonal="additive")

HW3$SSE # suma de cuadrados del error

#fitted(HW3) # entrega los valores ajustados, el nivel, la tendencia y la estacionalidad

# residuos:
res<-y-fitted(HW3)[,1] 

# coeficientes (recta de regresin y valores promedio por perodo):
# HW3$coefficients

# ponderaciones:
HW3$alpha
HW3$beta
HW3$gamma

HW3$SSE # suma de cuadrados del error

# grafico serie origunal y suavizada:
#plot(HW3)

# o bien
#plot(y)
#lines(fitted(HW3)[,1],col=3)

plot(fitted(HW3))

# -------------------------

# predicciones 

predicciones3 <- predict(HW3, n.ahead = 12, prediction.interval = TRUE, level = 0.95) 
# incluye intervalo de prediccion

predicciones3

plot(HW3, predicciones3)

##################################################################

# Ajustar el modelo de Holt-Winters multiplicativo:

HW3m<-HoltWinters(y,seasonal="multiplicative")

HW3m$SSE # suma de cuadrados del error

plot(HW3m)

# ponderaciones:

HW3m$alpha
HW3m$beta
HW3m$gamma

plot(fitted(HW3m))

# ------------------------

# predicciones 

predicciones3m <- predict(HW3m, n.ahead = 12, prediction.interval = TRUE, level = 0.95) 
# incluye intervalo de prediccion

predicciones3m

plot(HW3m, predicciones3m)

#--------------------------------------------------------------



